Overview
-----------

This interface layer handles the communication between a `IBM WAS ND DM` and `IBM WAS ND Node` charms.
The provider side of this interface provides the WAS ND DM service. The consumer/Requires part will be the WAS ND Node which wants the WAS ND DM dmgruser, dmgrpw, hostname, dminstallpath and profile name to configure the WAS ND dynamic cluster.


Usage
------

#### Provides
IBM WebSphere Application Server ND DM will provide this interface. This interface layer will set the following states, as appropriate:

 - `{relation_name}.connected`: The relation is established, WAS ND DM service is ready to send it's information.
 
 - `{relation_name}.available`: WAS ND DM has provided its connection information, and is ready to accept requests from the WAS ND Node charm.
 
 - `{relation_name}.departed` : The relation has been removed. Any cleanup related to the consumer charm(WAS ND Node) should happen now on the WAS ND DM charm since the consumer is going away.


#### Requires

Consumer charm `IBM WAS ND Node` will require this interface to connect to WAS ND DM so that they can share information to configure dynamic cluster setup. This interface layer will set the following states, as appropriate:

- `{relation_name}.connected` : The consumer charm has been related to a WAS ND DM provider charm. At this point, the charm waits for Provider charm to send configuration details like dmgruser, dmgrpw, hostname, dminstallpath and profile name.

- `{relation_name}.ready` : WAS ND Node is now ready to access the configuration details provided by WAS ND DM charm. The WAS ND Node charm can access the configuration details using the below methods:

    - `get_was_dm_install_path()` - returns the Installation path of WAS ND DM.
    - `get_was_dm_hostname()` - returns host name of WAS ND DM.
    - `get_dmgradminuser()` - returns user name to login DM console.
    - `get_dmgrpwd()` - returns password to login DM console.
    - `get_was_dm_profile_name()` - returns the WAS ND DM profile name.
	
Once the relation established, send the WAS ND Node host name to WAS ND DM. 
    - `set_was_node_hostname()` - returns running port of WAS.


