from charmhelpers.core import hookenv
from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes

class wasdmProvides(RelationBase):
    # Every unit connecting will get the same information
    scope = scopes.UNIT
    # convenient way to provide accessor methods
    #auto_accessors = ['was_path', 'was_port']

    @hook('{provides:dm-node}-relation-{joined}')
    def joined(self):
        conversation = self.conversation()
        conversation.set_state('{relation_name}.connected')
        conversation.remove_state('{relation_name}.departed')
        print("In joined hook of was-nd interface")

    
    @hook('{provides:dm-node}-relation-changed')
    def changed(self):
        conversation = self.conversation()
        conversation.set_state('{relation_name}.available')

    @hook('{provides:dm-node}-relation-{broken}')
    def broken(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.connected')
        conversation.set_state('{relation_name}.available')
        conversation.set_state('{relation_name}.departed')
        print("In broken hook in was-nd interface")

    def dismiss(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.departed')
            print("In dismissed for sercive",service)

    def reset_states(self,service):
        conversation = self.conversation(service)
        conversation.remove_state('{relation_name}.connected')
        conversation.remove_state('{relation_name}.departed')

    def set_was_dm_details(self, hostname, dminstallpath, profilename, dmgruser, dmgrpwd):
        for conversation in self.conversations():
            conversation.set_remote(data={
            'hostname': hostname,
            'dminstallpath': dminstallpath,
            'profilename': profilename,
            'dmgruser': dmgruser,
            'dmgrpwd': dmgrpwd
        })

    def get_was_node_ip(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip

    def get_was_node_hostname(self):
        hostnames = []
        for conv in self.conversations():
            hostnames.append(conv.get_remote('node_hostname'))
        return hostnames

    def services(self):
        """
        Return a list of services connecting to WASND.
        """
        service = []
        for conversation in self.conversations():
            service.append(conversation.scope)
        return service
