from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes
from subprocess import call
import socket
import os
import subprocess

class ihsRequires(RelationBase):
    scope = scopes.GLOBAL
    
    auto_accessors = ['hostname', 'dmgruser', 'dmgrpwd']
 
    @hook('{requires:dm-node}-relation-joined')
    def joined(self):
        self.remove_state('{relation_name}.departed')
        self.set_state('{relation_name}.connected')

    @hook('{requires:dm-node}-relation-changed')
    def changed(self):
        self.remove_state('{relation_name}.departed')
        print("Status is cluster-node.available in requires")
        if str(self.get_remote('hostname')) != "None":
               self.set_state('{relation_name}.ready')
               print("Status is cluster-node.ready in requires")	

    @hook('{requires:dm-node}-relation-departed')
    def departed(self):
        self.remove_state('{relation_name}.connected')
        self.remove_state('{relation_name}.ready')
        self.set_state('{relation_name}.departed')


    def get_was_dm_hostname(self):
        return self.get_remote('hostname')
    def get_was_dm_install_path(self):
        return self.get_remote('dminstallpath')
    def get_was_dm_profile_name(self):
        return self.get_remote('profilename')
    def get_dmgradminuser(self):
        return self.get_remote('dmgruser')
    def get_dmgrpwd(self):
        return self.get_remote('dmgrpwd')

    def set_was_node_hostname(self, node_hostname):
        for conversation in self.conversations():
            conversation.set_remote(data={
            'node_hostname': node_hostname
        })
    
