#!/usr/bin/env python3

import amulet
import re
import unittest

seconds_to_wait = 20000

class TestDeploy(unittest.TestCase):
    """
    Deployment test for the IBM WAS ND DM charm.
    """
    def setUp(self):
        self.d = amulet.Deployment(series='trusty')
        self.d.add('ibm-was-base', 'cs:~ibmcharmers/trusty/ibm-was-nd-dm')
		self.d.add('ibm-http', 'cs:~ibmcharmers/trusty/ibm-http')
		self.d.add('ibm-http', 'cs:~ibmcharmers/trusty/ibm-was-nd-node')
		self.d.relate('ibm-was-nd-dm:was-ihs', 'ibm-http:ihs')
		self.d.relate('ibm-was-nd-dm:dm-node', 'ibm-was-nd-node:cluster-node')
        self.d.setup(seconds_to_wait)
        self.d.sentry.wait(seconds_to_wait)

    def test_deploy_with_placeholder_resource(self):
        # The status message when using placeholder resources will include the
        # string "ibm_was_nd_installer resource". If we see that, the test is
        # successful.
        sentry_re = re.compile('ibm_was_nd_installer resource')
        self.d.sentry.wait_for_messages({"ibm-was-nd": sentry_re})
		
	def test_was_nd_dm_deployed(self):
	     self.assertTrue(self.d.deployed)
         unit = self.d.sentry['ibm-was-nd-dm'][0]
		 state_was_nd_dm = unit.info['agent-state']
		 print('WAS ND DM is %s' % state_was_nd_dm)
         url  = 'http://%s:9060/ibm/console' % unit.info['public-address']
		 https_url = 'https://%s:9043/ibm/console' % unit.info['public-address']
         response = requests.get(url, verify=False)
		 response = requests.get(https_url, verify=False)
        # Raise an exception if the url was not a valid web page.
         response.raise_for_status()
		 
	def test_was_nd_dm_ihs(self):
	    http_unit = self.d.sentry['ibm-http'][0]
        state_http = unit_master_0.info['agent-state']
		print('Http Server is %s' % state_http)
		url  = 'http://%s:80' % http_unit.info['public-address']
		snoop_url = 'http://%s:80/snoop' % http_unit.info['public-address']
		response = requests.get(url, verify=False)
		response = requests.get(snoop_url, verify=False)
		response.raise_for_status()
		
if __name__ == '__main__':
    unittest.main()